!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine AdvectDiffuseX
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: advectdiffusex.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!X αư˸ʲι
!Ĺ֥ƥå DelTimeLong ˤɾ. 
!
!   * ή
!   * ήȻ
!   * Ǵ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ήη׻ˤ ***_adv ȤʤѿѤ. 
!  * ήȻ, Ǵη׻ˤ ***_dif ȤʤѿѤ. 
!
!== Future Plans
!
                                                                 !=end
subroutine AdvectDiffuseX(                  &
     & fs_VelX_adv, sf_VelZ_adv,            & !ή
     & fs_VelX_dif, sf_VelZ_dif, ss_Km_dif, & !ήȻ, Ǵ
     & fs_AdvDiffX_out )
                                                                 !=begin
  !== Dependency
  use dc_trace, only: BeginSub, EndSub
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax, DelXZ
  use bcset,    only: ss_BC
  use arareset, only: Cm, NuH, NuV
  use average,  only: fs_avr_ss, ss_avr_fs, ff_avr_ss, fs_avr_ff, ff_avr_sf
  use differentiate_center4, only: ss_dx_fs, fs_dx_ss, fs_dz_ff, ff_dx_sf, &
       &                   ff_dz_fs, fs_dz_ff, ff_dz_fs, fs_dz_ff
                                                                 !=end  
  !== ۤηػ 
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: fs_VelX_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: fs_VelX_dif(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ_dif(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Km_dif(DimXMin:DimXMax, DimZMin:DimZMax)

  !== Output
  real(8), intent(out) :: fs_AdvDiffX_out(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end    
  !=== Work
  real(8)  :: fs_AdvVelX(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: fs_TurbVelX(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: fs_NumDiffVelX(DimXMin:DimXMax, DimZMin:DimZMax)
  
  call BeginSub("AdvectDiffuseX", &
       &        fmt="%c",    &
       &        c1="calculation of extra force term in x-direction.")


  !=== ή
  fs_AdvVelX = &
       &    fs_avr_ss( ss_avr_fs( fs_VelX_adv ) * ss_dx_fs( fs_VelX_adv ) ) &
       & +  fs_avr_ff( ff_avr_sf( sf_VelZ_adv ) * ff_dz_fs( fs_VelX_adv ) )


  !=== ήȻ ( t-t ɾ)
  fs_TurbVelX = &
       &   2.0d0 * fs_dx_ss( ss_Km_dif * ss_dx_fs( fs_VelX_dif ) ) &
       & + fs_dz_ff( ff_avr_ss( ss_Km_dif ) * ff_dx_sf( sf_VelZ_dif ) )  &
       & + fs_dz_ff( ff_avr_ss( ss_Km_dif ) * ff_dz_fs( fs_VelX_dif ) )  &
       & - 2.0d0 * fs_dx_ss( ( ss_Km_dif ** 2.0d0 ) ) &
       &   / ( 3.0d0 * ( Cm ** 2.0d0 ) * ( DelXZ ** 2.0d0 ) )   


  !=== Ǵ ( t-t ɾ)
  fs_NumDiffVelX = &
       &   NuH * ( fs_dx_ss( ss_dx_fs( fs_VelX_dif) ) ) &
       & + NuV * ( fs_dz_ff( ff_dz_fs( fs_VelX_dif) ) ) 
  

  !=== ϹȤƽ
  fs_AdvDiffX_out = - fs_AdvVelX + fs_TurbVelX + fs_NumDiffVelX 
  
  call EndSub("AdvectDiffuseX")
  
end subroutine AdvectDiffuseX
