!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine EddyViscosity
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: eddyviscosity.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!2.5 ή㡼Ѥ, 
!λαǴȱȻ륵֥롼.
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * 꼰 CReSS Υޥ˥奢򻲾Ȥ
!  * ήη׻ˤ ***_adv ȤʤѿѤ. 
!  * , Ȼ, ûη׻ˤ ***_dif ȤʤѿѤ. 
!
!== Future Plans
!
                                                                 !=end
subroutine EddyViscosity(                                   &
     & ss_Km_in,                                            &
     & DelTime,                                             & 
     & fs_VelX_adv, sf_VelZ_adv, ss_Km_adv,                 & !ή
     & fs_VelX_dif, sf_VelZ_dif, ss_PotTemp_dif, ss_Km_dif, & !, Ȼ, û
     & ss_Km_out, ss_Kh_out )
                                                                 !=begin
  !== Dependency
  use dc_trace, only: BeginSub, EndSub
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax, DelXZ
  use bcset,    only: ss_BC
  use physset,  only: Grav
  use basicset, only: ss_PotTempBasicZ
  use arareset, only: Cm
  use average,  only: ss_avr_fs, ss_avr_ff, ss_avr_sf
  use differentiate_center4, only: fs_dx_ss, ss_dx_fs, ff_dx_sf, &
       &                   ss_dz_sf, sf_dz_ss, ff_dz_fs
                                                                 !=end
  !== ۤηػ
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: DelTime
  real(8), intent(in)  :: ss_Km_in(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: fs_VelX_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Km_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: fs_VelX_dif(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ_dif(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_PotTemp_dif(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Km_dif(DimXMin:DimXMax, DimZMin:DimZMax)

  !== Output
  real(8), intent(out) :: ss_Km_out(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(out) :: ss_Kh_out(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end
  !== Work
  real(8)  :: ss_AdvKm(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_BuoyKm(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_ShearKm(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_DiffKm(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_DispKm(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_TendKm(DimXMin:DimXMax, DimZMin:DimZMax)
  

  call BeginSub("EddyViscosity", &
       &        fmt="%c",    &
       &        c1="calculation of eddy viscosity whith 2.5 order closure.")


  !=== 顼̤ΰή. 濴ʬ. 
  ss_AdvKm = &
       &   ss_avr_fs( fs_VelX_adv * fs_dx_ss( ss_Km_adv ) ) &
       & + ss_avr_sf( sf_VelZ_adv * sf_dz_ss( ss_Km_adv ) ) 


  !=== Ϥˤήͥ륮
  ss_BuoyKm = &
       &    3.0d0 * Grav * ( Cm ** 2.0d0 ) * ( DelXZ ** 2.0d0 ) &
       &       * ss_avr_sf( sf_dz_ss( ss_PotTemp_dif ) ) &
       &       / ( 2.0d0 * ss_PotTempBasicZ )

  
  !=== ®٥ˤήͥ륮
  ss_ShearKm = &
       &  ( Cm ** 2.0d0 ) * ( DelXZ ** 2.0d0 )               &
       &    * (                                              &
       &          ( ss_dx_fs( fs_VelX_dif ) ) ** 2.0d0        &
       &       + ( ss_dz_sf( sf_VelZ_dif ) ) ** 2.0d0         &
       &       + ( (   ss_avr_ff( ff_dz_fs( fs_VelX_dif ) )   &
       &             + ss_avr_ff( ff_dx_sf( sf_VelZ_dif ) )   &
       &           ) ** 2.0d0 ) / 2.0d0                      &
       &      )                                              &
       & - ss_Km_dif                                          &
       &    * ( ss_dx_fs( fs_VelX_dif ) + ss_dz_sf( sf_VelZ_dif ) ) / 3.0d0

  
  !=== ήͥ륮γȻ
  ss_DiffKm =                                                 &
       &     ss_dx_fs( fs_dx_ss( ss_Km_dif ) ) / 2.0d0        &
       &   + ss_dz_sf( sf_dz_ss( ss_Km_dif ) ) / 2.0d0        &
       &   + ( ss_avr_fs( fs_dx_ss( ss_Km_dif ) ) ) ** 2.0d0  & 
       &   + ( ss_avr_sf( sf_dz_ss( ss_Km_dif ) ) ) ** 2.0d0
  

  !=== ήͥ륮ξû
  ss_DispKm = ( ss_Km_dif ** 2.0d0 ) / ( 2.0d0 * ( DelXZ ** 2.0d0 ) )
  
  
  !=== ޤȤ
  ss_TendKm = - ss_AdvKm  - ss_BuoyKm  +  ss_ShearKm &
       &      + ss_DiffKm - ss_DispKm 

  
  !=== ʬ
  ss_Km_out = ss_Km_in + DelTime * ss_TendKm


  !=== 
  call boundary( ss_BC, ss_Km_out )
  

  !=== ΰ˸
  where ( ss_Km_out < 0.0d0 )
     ss_Km_out = 0.0d0
  end where

  
  !=== Ȼ
  ss_Kh_out = 3.0d0 * ss_Km_out


  call EndSub("EddyViscosity")
  
end subroutine EddyViscosity
