!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine Scalar
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: scalar.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!顼̤λȯŸ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ήη׻ˤ ***_adv ȤʤѿѤ. 
!  * , ήȻ, Ǵη׻ˤ ***_dif ȤʤѿѤ. 
!
!== Future Plans
!
                                                                 !=end
subroutine Scalar(                              & 
     & ss_Scalar_in,                            &
     & DelTime,                                 &
     & fs_VelX_adv, sf_VelZ_adv, ss_Scalar_adv, & !ή
     & ss_Scalar_dif, ss_Kh_dif,                & !, ήȻ, Ǵ
     & ss_Scalar_out)
                                                                 !=begin  
  use dc_trace, only: BeginSub, EndSub
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
  use bcset,    only: ss_BC
  use average,  only: ss_avr_sf
  use basicset, only: ss_PotTempBasicZ
  use arareset, only: NuH, NuV
  use average,  only: ss_avr_fs, ss_avr_sf, fs_avr_ss, sf_avr_ss
  use differentiate_center4, only: fs_dx_ss, ss_dx_fs, sf_dz_ss, ss_dz_sf
                                                                 !=end
  !== ۤηػ
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: DelTime
  real(8), intent(in)  :: ss_Scalar_in(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: fs_VelX_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Scalar_adv(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Scalar_dif(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Kh_dif(DimXMin:DimXMax, DimZMin:DimZMax)

  !== Output
  real(8), intent(out) :: ss_Scalar_out(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end  
  !== Work
  real(8)  :: ss_AdvScalar(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_SrcScalar(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_TurbScalar(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_NumDiffScalar(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_TendScalar(DimXMin:DimXMax, DimZMin:DimZMax)
  
  call BeginSub("Scalar", &
       &        fmt="%c",              &
       &        c1="Time integration of scalar component.")
  
  !=== ήη׻. 濴ʬѤƷ׻. 
  ss_AdvScalar = &
       &   ss_avr_fs( fs_VelX_adv * fs_dx_ss( ss_Scalar_adv ) ) &
       & + ss_avr_sf( sf_VelZ_adv * sf_dz_ss( ss_Scalar_adv ) ) 

!  !=== ήη׻. MPDATA ѤƷ׻
!  call AdvectScalar_MPDATA( fs_VelX_adv, sf_VelZ_adv, &
!       &                    ss_Scalar_adv, DelTime, &
!       &                    ss_AdvScalar_adv )


  !=== 
  ss_SrcScalar = ss_avr_sf( sf_VelZ_adv * sf_dz_ss( ss_PotTempBasicZ ) ) 
  
  !=== ήȻ ( t - t ɾ)
  ss_TurbScalar = &
       &    ss_dx_fs( fs_avr_ss(ss_Kh_dif) * fs_dx_ss( ss_Scalar_dif ) ) &
       &  + ss_dz_sf( sf_avr_ss(ss_Kh_dif) * sf_dz_ss( ss_Scalar_dif ) ) 

  
  !=== Ǵ ( t - t ɾ)
  ss_NumDiffScalar = &
       &   NuH * ( ss_dx_fs( fs_dx_ss( ss_Scalar_dif) ) ) &
       & + NuV * ( ss_dz_sf( sf_dz_ss( ss_Scalar_dif) ) ) 
  
  !=== ޤȤ
  ss_TendScalar = &
       & - ss_AdvScalar  - ss_SrcScalar      &
       & + ss_TurbScalar + ss_NumDiffScalar
  
  !=== ̤λʬ
  ss_Scalar_out = ss_Scalar_in + DelTime * ss_TendScalar

  !=== 
  call boundary(ss_BC, ss_Scalar_out)
  
  call EndSub("Scalar")
  
contains
                                                                 !=begin
!== Subroutine AdvectScalar_MPDATA
!
!   * Developer: ODAKA Masatsugu (odakker@gfd-dennou.org)
!   * Version: $Id: scalar.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!=== Overview 
!
! 顼̤ΰή MPDATA ѤƷ׻. 
!
!=== Error Handling
!
!=== Known Bugs
!
!=== Note
!
! Թ, ʬʺʬѤƹԤ.
! °Ϥѿλ֥٥դ뤳.
!
! ήξ,  fs_VelX, fs_VelZ λ֥٥ ss_Scalar 
! ֥٥뤫 DelTime/2 ԤΤˤ.
!
! ®پ leapfrog ǲ򤯾˴ñ˼ʤ,  t ˤ
! fs_VelX_n, fs_VelZ_n Ѥƻֹ 2*DelTime ʺʬȤ ss_Scala
! ʬ.
!
!       t-t           t           t+t
!    -----|-------------|-------------|-----
!             [fs_VelX_n,sf_VelZ_n]
!    ss_Scalar_b                  ss_Scalar_a 
!         |======== 2*DelTime =======>|
!
!
! ɤ׻ʤ t+t/2 ˤ fs_VelX_mid, sf_VelZ_mid  
! Ѥƻֹ DelTime ʺʬȤ ss_Scalar ׻.
!
!       t-t           t           t+t
!    -----|-------------|------|------|-----
!                   [fs_VelX_mid,sf_VelZ_mid]
!                   s_Scalar_n   ss_Scalar_a 
!                       |== DelTime =>|
!
!=== Future Plans
!
                                                                 !=end
subroutine AdvectScalar_MPDATA(fs_VelX, sf_VelZ, &
&                              ss_Scalar, DelTime, ss_AdvScalar)
                                                                 !=begin
  !=== Dependency
  use dc_trace,      only: BeginSub, EndSub 
  use gridset,       only: DimXMin, DimXMax, DimZMin, DimZMax, DelX, DelZ
  use average,       only: fs_avr_sf, sf_avr_fs, sf_avr_ss, fs_avr_ss
  use bcset,         only: ss_BC, sf_BC, fs_BC
  use differentiate_center4, only: fs_dx_ss, sf_dz_ss, ss_dx_fs, ss_dz_sf
                                                                 !=end  
  !=== ۤηػ
  implicit none
                                                                 !=begin
  !=== Input
  real(8), intent(in)  :: fs_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Scalar(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: DelTime

  !=== Output
  real(8), intent(out) :: ss_AdvScalar(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end

  !=== Work
  real(8) :: ss_Scalar_tmp(DimXMin:DimXMax, DimZMin:DimZMax)   ! 
  real(8) :: ss_AdvScalar_tmp(DimXMin:DimXMax, DimZMin:DimZMax)! 
  real(8) :: ss_DivVel(DimXMin:DimXMax, DimZMin:DimZMax)       ! ȯ
  real(8) :: fs_FluxX(DimXMin:DimXMax, DimZMin:DimZMax)        ! եå
  real(8) :: sf_FluxZ(DimXMin:DimXMax, DimZMin:DimZMax)        ! եå
  real(8) :: fs_AntiDiffVelX(DimXMin:DimXMax, DimZMin:DimZMax) ! ȿȻ®
  real(8) :: sf_AntiDiffVelZ(DimXMin:DimXMax, DimZMin:DimZMax) ! ȿȻ®
  real(8) :: fs_AntiDiffFluxX(DimXMin:DimXMax, DimZMin:DimZMax)! եå
  real(8) :: sf_AntiDiffFluxZ(DimXMin:DimXMax, DimZMin:DimZMax)! եå


  call BeginSub("AdvectScalar_MPDATA", &
&               fmt="%c",       &
&          c1="Calculate advection term for scalar variables (ss_AdvScalar).")

  !=== 

  fs_FluxX = 0.0d0 ; sf_FluxZ = 0.0d0 ; ss_AdvScalar = 0.0d0

  !=== ήʬˡѤƥ顼Υեå׻

  call FluxScalar(fs_VelX, sf_VelZ, ss_Scalar, fs_FluxX, sf_FluxZ)


  !=== ȯη׻

  ss_DivVel =  ss_dx_fs( fs_VelX ) + ss_dz_sf( sf_VelZ )

  !=== ήˤʬ׻

  ss_AdvScalar = ss_dx_fs(fs_FluxX) + ss_dz_sf(sf_FluxZ)  
!&                - ss_Scalar * ss_DivVel

  !=== 顼βͤ׻

  ss_Scalar_tmp = ss_Scalar + DelTime * ( - ss_AdvScalar )
!  call Integral(- ss_AdvScalar, DelTime, ss_Scalar, ss_Scalar_tmp )

  call boundary(ss_BC, ss_Scalar_tmp)


  !=== MPDATA ˤ

  !=== 

  fs_AntiDiffVelX  = 0.0d0 
  sf_AntiDiffVelZ  = 0.0d0
  fs_AntiDiffFluxX = 0.0d0 
  sf_AntiDiffFluxZ = 0.0d0
  ss_AdvScalar_tmp = 0.0d0
  ss_DivVel        = 0.0d0
 

  !=== ήʬˤ륹顼եå 0 ǤʤȿȻ®٤׻

  where(fs_FluxX /= 0.0d0)

    fs_AntiDiffVelX = 0.5d0 * (                                               &
&     (abs(fs_VelX)*DelX - DelTime*fs_VelX**2)*fs_dx_ss(ss_Scalar_tmp)        &
&    - DelTime*fs_VelX*fs_avr_sf(sf_VelZ)*fs_avr_sf(sf_dz_ss(ss_Scalar_tmp))) &
&     / (Max(fs_avr_ss(ss_Scalar_tmp), epsilon(0.0d0)))                       &
&    - 0.5d0*fs_VelX*fs_avr_ss(ss_DivVel)

  end where

  where (sf_FluxZ /= 0.0d0) 

    sf_AntiDiffVelZ = 0.5d0 * (                                               &
&     (abs(sf_VelZ)*DelZ - DelTime*sf_VelZ**2)*sf_dz_ss(ss_Scalar_tmp)        &
&    - DelTime*sf_VelZ*sf_avr_fs(fs_VelX)*sf_avr_fs(fs_dx_ss(ss_Scalar_tmp))) &
&     / (MAX(sf_avr_ss(ss_Scalar_tmp), epsilon(0.0d0)))                       &
&    - 0.5d0*sf_VelZ*sf_avr_ss(ss_DivVel)

  end where

  !=== ȿȻ®٤ˤ͢
  ! ȿȻ®٤ºݤ®٤ۤƤͤ 0 ˤ.

  where(abs(fs_AntiDiffVelX) > abs(fs_VelX) )
;    fs_AntiDiffVelX = 0.0d0
  end where

  where(abs(sf_AntiDiffVelZ) > abs(sf_VelZ) )
    sf_AntiDiffVelZ = 0.0d0
  end where


  !=== ȿȻ®٤ȾήʬˡѤƥ顼Υեå׻

  call FluxScalar(fs_AntiDiffVelX, sf_AntiDiffVelZ, ss_Scalar_tmp, &
&                 fs_AntiDiffFluxX, sf_AntiDiffFluxZ) 

  !=== ȿȻ®٤ΰήˤʬ׻
  ss_AdvScalar_tmp = ss_dx_fs(fs_AntiDiffFluxX) + ss_dz_sf(sf_AntiDiffFluxZ)


  !=== ʬ׻
  ss_AdvScalar = ss_AdvScalar_tmp + ss_AdvScalar

  call EndSub("AdvectScalar_MPDATA")

end subroutine AdvectScalar_MPDATA

!!!
!!! ήʬˡѤƥ顼Υեå׻
!!!
subroutine FluxScalar(fs_VelX, sf_VelZ, ss_Scalar, &
&                       fs_FluxX, sf_FluxZ)

    real(8), intent(in)  :: fs_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)  :: sf_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)  :: ss_Scalar(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(out) :: fs_FluxX(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(out) :: sf_FluxZ(DimXMin:DimXMax, DimZMin:DimZMax)
   

    fs_FluxX(DimXMin:DimXMax-1, :) =  (&
&      (fs_VelX(DimXMin:DimXMax-1, :) + abs(fs_VelX(DimXMin:DimXMax-1, :))) &
&              *ss_Scalar(DimXMin:DimXMax-1, :)       &
&     +(fs_VelX(DimXMin:DimXMax-1, :) - abs(fs_VelX(DimXMin:DimXMax-1, :))) &
&              *ss_Scalar(DimXMin+1:DimXMax, :) )*0.5d0

    sf_FluxZ(:, DimZMin:DimZMax-1) =  (& 
&       (sf_VelZ(:, DimZMin:DimZMax-1) + abs(sf_VelZ(:, DimZMin:DimZMax-1))) &
&              *ss_Scalar(:, DimZMin:DimZMax-1)       &
&     + (sf_VelZ(:, DimZMin:DimZMax-1) - abs(sf_VelZ(:, DimZMin:DimZMax-1))) &
&              *ss_Scalar(:, DimZMin+1:DimZMax) )*0.5d0


  end subroutine FluxScalar
  
end subroutine Scalar
