!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine VelocityX
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: velocityx.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!顼ˡѤ X ®٤η׻. 
!deepconv/arare ǤϻʬȤ He-VI ˡѤƤΤ, 
!X ®٤۲ˡǲ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ʡؿζΥˤ, 2 ٤ΥۤѤƤ뤿, ܥ֥ץˤƤ differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!
                                                                 !=end

subroutine VelocityX(                           &
     & fs_VelX_in,                              &
     & DelTime,                                 &
     & fs_AdvDiffX, fs_VelX, sf_VelZ, ss_Exner, &
     & fs_VelX_out )
                                                                 !=begin
  !== Dependency
  use dc_trace, only: BeginSub, EndSub
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
  use basicset, only: ss_CpBasicZ, ss_PotTempBasicZ
  use bcset,    only: fs_BC
  use arareset, only: alpha
  use average,  only: fs_avr_ss
  use differentiate_center2,  only: fs_dx_ss, ss_dx_fs, ss_dz_sf

                                                                 !=end  
  !== ۤηػ
  implicit none
                                                                 !=begin  
  !== Input
  real(8), intent(in)    :: DelTime
  real(8), intent(in)    :: fs_VelX_in(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)    :: ss_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)    :: fs_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)    :: sf_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)    :: fs_AdvDiffX(DimXMin:DimXMax, DimZMin:DimZMax)

  !== Output
  real(8), intent(out)   :: fs_VelX_out(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end  
  !== Work
  real(8)                :: ss_DivVel(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)                :: fs_PressGradVelX(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)                :: fs_TendVelX(DimXMin:DimXMax, DimZMin:DimZMax)


  call BeginSub("VelocityX", &
&           fmt="%c",        &
&           c1="Calculate VelXShort (fs_VelX).")

  !=== ®٤μ«
  ss_DivVel =  ss_dx_fs( fs_VelX ) + ss_dz_sf( sf_VelZ )
  

  !=== ® u η׻ (Ϸ٤ʺʬɾ)
  fs_PressGradVelX =  &
       & - fs_avr_ss( ss_CpBasicZ * ss_PotTempBasicZ )  &
       &   * ( fs_dx_ss( ss_Exner ) - fs_dx_ss( alpha * ss_DivVel ) )  


  !=== ʬɾ
  fs_TendVelX = fs_PressGradVelX + fs_AdvDiffX
  

  !=== ʬ
  fs_VelX_out = fs_VelX_in + DelTime * fs_TendVelX
  

  !=== 
  call boundary(fs_BC, fs_VelX_out)
  

  call EndSub("VelocityX")
  
end subroutine VelocityX


    
