!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine VelocityZ
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: velocityz.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!顼ˡѤ Z ®٤η׻. 
!deepconv/arare ǤϻʬȤ He-VI ˡѤƤΤ, 
!Z ®٤ϱˡǲ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ʡؿζΥˤ, 2 ٤ΥۤѤƤ뤿, ܥ֥ץˤƤ differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!
                                                                 !=end
subroutine VelocityZ(  &
     & sf_VelZ_in, &
     & DelTime,    &
     & sf_AdvDiffZ, fs_VelX, sf_VelZ, ss_Exner_n, ss_Exner_a, &
     & sf_VelZ_out )
                                                                 !=begin
  !== Dependency
  use dc_trace, only: BeginSub, EndSub  
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
  use basicset, only: ss_CpBasicZ, ss_PotTempBasicZ
  use bcset,    only: sf_BC
  use arareset, only: alpha, beta
  use average,  only: sf_avr_ss
  use differentiate_center2,  only: ss_dx_fs, ss_dz_sf, sf_dz_ss

                                                                 !=end  
  !== ۤηػ
  implicit none
                                                                 !=begin  
  !== Input
  real(8), intent(in)   :: DelTime
  real(8), intent(in)   :: sf_VelZ_in(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)   :: ss_Exner_n(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)   :: ss_Exner_a(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)   :: fs_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)   :: sf_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)   :: sf_AdvDiffZ(DimXMin:DimXMax, DimZMin:DimZMax)

  !== Output
  real(8), intent(out)  :: sf_VelZ_out(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end  
  !== Work
  real(8)               :: ss_DivVel(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)               :: sf_PressGradVelZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)               :: sf_TendVelZ(DimXMin:DimXMax, DimZMin:DimZMax)


  call BeginSub("VelocityZ", &
&           fmt="%c",        &
&           c1="Calculate VelZ_backward (sf_VelZ).")

  !=== ®٤μ«
  ss_DivVel =  ss_dx_fs( fs_VelX ) + ss_dz_sf( sf_VelZ )
  

  !=== ® w ΰϸ
  sf_PressGradVelZ =   &
       & - sf_avr_ss( ss_CpBasicZ * ss_PotTempBasicZ )      &
       &   * (                                              &
       &       beta * sf_dz_ss( ss_Exner_a )               &
       &       + (1.0d0 - beta) * sf_dz_ss( ss_Exner_n )   &
       &       - sf_dz_ss( alpha * ss_DivVel )           &
       &     )                                              


  !=== ʬɾ
  sf_TendVelZ = sf_PressGradVelZ + sf_AdvDiffZ

  
  !=== ʬ
  sf_VelZ_out = sf_VelZ_in + DelTime * sf_TendVelZ


  !=== 
  call boundary(sf_BC, sf_VelZ_out)
  

  call EndSub("VelocityZ")
  
end subroutine VelocityZ
