!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Program MakeReStartFile
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: makerestartfile.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
! or ꥹѤξξ netCDF ե˽Ϥ뤿Υ롼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!®٤ɾʻҰ֤, ȤϤƤɸͤŪǤʤȤ
!
!== Future Plans
!
                                                                 !=end
subroutine MakeReStartFile( File, Time, &
     & fs_VelX_bl,    sf_VelZ_bl,  ss_Exner_bl,  &
     & ss_PotTemp_bl, ss_Km_bl,    ss_Kh_bl,     &
     & fs_VelX_nl,    sf_VelZ_nl,  ss_Exner_nl,  &
     & ss_PotTemp_nl, ss_Km_nl,    ss_Kh_nl      )
                                                                 !=begin
  !== Dependency
  use gt4_history
  use dc_trace, only: BeginSub, EndSub
  use gridset,  only: s_X, s_Z, DimXMin, DimXMax, DimZMin, DimZMax
  use nameset,  only: exptitle, expsrc, expinst
  use debugset, only: DebugOn
  use basicset, only: ss_CpBasicZ, ss_DensBasicZ, ss_ExnerBasicZ, &
       &                  ss_PotTempBasicZ, ss_VelSoundBasicZ 
                                                                 !=end  
  !== ۤηػ
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: Time(2)
  real(8), intent(in)  :: fs_VelX_nl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Exner_nl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_PotTemp_nl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Km_nl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Kh_nl(DimXMin:DimXMax, DimZMin:DimZMax)

  real(8), intent(in)  :: fs_VelX_bl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ_bl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Exner_bl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_PotTemp_bl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Km_bl(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Kh_bl(DimXMin:DimXMax, DimZMin:DimZMax)

  character(*), intent(in) :: File
                                                                 !=end

  !== Work
  integer   :: N, M

  call BeginSub("MakeReStartFile",   &
&                fmt="%c",         &
&     c1="Initialize output file name and variables.")

  N = size(s_X, 1)
  M = size(s_Z, 1)

  !=== ҥȥ꡼
  call HistoryCreate(                                 &
       & file = File,                            &
       & title = exptitle,                            &
       & source = expsrc,                             &
       & institution = expinst,                       &
       & dims=(/'x','z','t'/),                        &
       & dimsizes=(/N, M, 2/),                        &
       & longnames=(/'X-coordinate',                  &
       &             'Z-coordinate',                  &
       &             'Time        '/),                &
       & units=(/'m','m','s'/), origin=0.0,           &
       & interval=0.0 )
  
  !=== ѿ
  call HistoryPut('x', s_X )
  call HistoryPut('z', s_Z )
  call HistoryPut('t', Time )
  
  !=== ̵
  call HistoryAddVariable(                            &
       & varname='Exner_n', dims=(/'x','z'/),         &
       & longname='nondimensional pressure',          &
       & units='1',                                   &
       & xtype='double' )
  !=== ̵
  call HistoryAddVariable(                            &
       & varname='Exner_b', dims=(/'x','z'/),         &
       & longname='nondimensional pressure',          &
       & units='1',                                   &
       & xtype='double' )
  !=== 
  call HistoryAddVariable(                            &
       & varname='PotTemp_n', dims=(/'x','z'/),       &
       & longname='virtual potential temperature',    &
       & units='K',                                   &
       & xtype='double' )
  !=== 
  call HistoryAddVariable(                            &
       & varname='PotTemp_b', dims=(/'x','z'/),       &
       & longname='virtual potential temperature',    &
       & units='K',                                   &
       & xtype='double' )
  !=== ®
  call HistoryAddVariable(                            &
       & varname='VelX_n', dims=(/'x','z'/),          &
       & longname='zonal velocity',                   &
       & units='m/s',                                 &
       & xtype='double' )
  !=== ®
  call HistoryAddVariable(                            &
       & varname='VelX_b', dims=(/'x','z'/),          &
       & longname='zonal velocity',                   &
       & units='m/s',                                 &
       & xtype='double' )
  !=== ®
  call HistoryAddVariable(                            &
       & varname='VelZ_n', dims=(/'x','z'/),          &
       & longname='vertical velocity',                &
       & units='m/s',                                 &
       & xtype='double' )
  !=== ®
  call HistoryAddVariable(                            &
       & varname='VelZ_b', dims=(/'x','z'/),          &
       & longname='vertical velocity',                &
       & units='m/s',                                 &
       & xtype='double' )
  !=== Ǵ
  call HistoryAddVariable(                            &
       & varname='Km_n', dims=(/'x','z'/),            &
       & longname='Km',                               &
       & units='1',                                   &
       & xtype='double' )
  !=== Ǵ
  call HistoryAddVariable(                            &
       & varname='Km_b', dims=(/'x','z'/),            &
       & longname='Km',                               &
       & units='1',                                   &
       & xtype='double' )
  !=== Ȼ
  call HistoryAddVariable(                            &
       & varname='Kh_n', dims=(/'x','z'/),            &
       & longname='Kh',                               &
       & units='1',                                   &
       & xtype='double' )
  !=== Ȼ
  call HistoryAddVariable(                            &
       & varname='Kh_b', dims=(/'x','z'/),            &
       & longname='Kh',                               &
       & units='1',                                   &
       & xtype='double' )
  !=== ̵
  call HistoryAddVariable(                             &
       & varname='ExnerBasicZ', dims=(/'x','z'/),      &
       & longname='nondimensional pressure', units='1',&
       & xtype='double' )
  !=== 
  call HistoryAddVariable(                            &
       & varname='PotTempBasicZ', dims=(/'x','z'/),    &
       & longname='potential temperature',            &
       & units='K', xtype='double' )
  !=== 갵Ǯ
  call HistoryAddVariable(                            &
       & varname='CpBasicZ', dims=(/'x','z'/),        &
       & longname='Specific Heat',                    &
       & units='J/K kg', xtype='double' )
  !=== ̩
  call HistoryAddVariable(                            &
       & varname='DensBasicZ', dims=(/'x','z'/),      &
       & longname='density',                          &
       & units='Kg/m^3', xtype='double' )
  !=== ®
  call HistoryAddVariable(                            &
       & varname='VelSoundBasicZ', dims=(/'x','z'/),  &
       & longname='sound velocity',                   &
       & units='m/s^2', xtype='double' ) 
  

  !=== ե
  call HistoryPut( 'VelX_n',    fs_VelX_nl    )
  call HistoryPut( 'VelZ_n',    sf_VelZ_nl    )
  call HistoryPut( 'Exner_n',   ss_Exner_nl   ) 
  call HistoryPut( 'PotTemp_n', ss_PotTemp_nl )
  call HistoryPut( 'Km_n',      ss_Km_nl      )
  call HistoryPut( 'Kh_n',      ss_Kh_nl      )
  
  call HistoryPut( 'VelX_b',    fs_VelX_bl    )
  call HistoryPut( 'VelZ_b',    sf_VelZ_bl    )
  call HistoryPut( 'Exner_b',   ss_Exner_bl   ) 
  call HistoryPut( 'PotTemp_b', ss_PotTemp_bl )
  call HistoryPut( 'Km_b',      ss_Km_bl      )
  call HistoryPut( 'Kh_b',      ss_Kh_bl      )
  
  call HistoryPut( 'CpBasicZ',       ss_CpBasicZ       )
  call HistoryPut( 'DensBasicZ',     ss_DensBasicZ     )
  call HistoryPut( 'ExnerBasicZ',    ss_ExnerBasicZ    )
  call HistoryPut( 'PotTempBasicZ',  ss_PotTempBasicZ  )
  call HistoryPut( 'VelSoundBasicZ', ss_VelSoundBasicZ )

  !=== եĤ
  call HistoryClose

  
  call EndSub("MakeReStartFile")

end subroutine MakeReStartFile
