!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module DisturbSet_calc
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: disturbset.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!ɤ߹, ͤ׻. 
!
!ŵŪʾȤưʲǽ. 
!   * ̵: ʤ or X ʬ or Z ʬ or XZ ʬ 
!   * : ʤ or X ʬ or Z ʬ or XZ ʬ 
!   * ®: ʤ or X ®ٰ or Z ®ٰ 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!  * ǽʾΥפ䤹
!  * 顼 gf4f90io 
!
                                                                 !=end

module disturbset
  !== ۤηػ
  implicit none

  !== save °
  save
                                                                 !=begin
  !== Public Interface
  real(8), allocatable  :: ss_PotTempDisturb(:, :) !
  real(8), allocatable  :: ss_ExnerDisturb(:, :)   !ʡؿ
  real(8), allocatable  :: fs_VelXDisturb(:, :)    !® u
  real(8), allocatable  :: sf_VelZDisturb(:, :)    !® w
                                                                 !=end

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NAMELIST νץ disturb ɤ߼. 
  !
  subroutine disturbset_calc_init(cfgfile)
    !=== Dependency
    use dc_trace,   only: BeginSub, EndSub 
    use dc_message, only: MessageNotify
    use gridset,    only: s_X, s_Z, f_X, f_Z, Xmin, Xmax, Zmin, Zmax, &
         &                DimXMin, DimXMax, DimZMin, DimZMax
    use physset,    only: MolWtDry, CpDry, Pi
    
    !=== Input
    character(*), intent(in) :: cfgfile
                                                                 !=end
    !=== Work
    character(80) :: ExnerDisturbType !̵Ϥξ (DisturbType.f90 )
    real(8)       :: ExnerSigmaX      ! (X )
    real(8)       :: ExnerSigmaZ      ! (Z )
    real(8)       :: ExnerMax         !κ
    real(8)       :: ExnerCenterX     !濴 (X )
    real(8)       :: ExnerCenterZ     !濴 (X )
    
    character(80) :: PotTempDisturbType  !̤ξ (DisturbType.f90 )
    real(8)       :: PotTempSigmaX       ! (X )
    real(8)       :: PotTempSigmaZ       ! (X )
    real(8)       :: PotTempMax          !κ
    real(8)       :: PotTempCenterX      !濴 (X )
    real(8)       :: PotTempCenterZ      !濴 (X )
    
    character(80) :: VelDisturbType   !®٤ξ (DisturbType.f90 )
    real(8)       :: VelX             !® u 
    real(8)       :: VelZ             !® w

    integer :: i, k
    real(8) :: mu
    real(8) :: sigma
                                                                 !=end
                                                                 !=begin
    !=== NAMELIST
    NAMELIST /disturbset/ &
         & ExnerDisturbType, ExnerMax, ExnerSigmaX, ExnerSigmaZ, &
         &                  ExnerCenterX, ExnerCenterZ, &
         & PotTempDisturbType, PotTempMax, PotTempSigmaX, PotTempSigmaZ, &
         &                  PotTempCenterX, PotTempCenterZ, &
         & VelDisturbType, VelX, VelZ
                                                                 !=end    
    call BeginSub("disturbset_calc_init", &
&                 fmt="%c",       &
&                 c1="Initialize values of disturbance. ")


    open (10, FILE=cfgfile)
    read(10, NML=disturbset)
    close(10)

    !==== ѿͤΥå

    if ( ExnerSigmaX > 1 )  then 
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "SigmaX is > 1")
       stop
    end if

    if ( ExnerSigmaZ > 1 )  then
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "SigmaZ is > 1")
       stop
    end if

    if ( PotTempSigmaX > 1 )  then 
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "SigmaX is > 1")
       stop
    end if

    if ( PotTempSigmaZ > 1 )  then
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "SigmaZ is > 1")
       stop
    end if

    if ( ExnerCenterX > 1 ) then 
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "CenterX is > 1")
       stop
    end if

    if ( ExnerCenterZ > 1 ) then
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "CenterZ is > 1")
       stop
    end if

    if ( PotTempCenterX > 1 ) then 
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "CenterX is > 1")
       stop
    end if

    if ( PotTempCenterZ > 1 ) then
       call MessageNotify("Message", "disturbset_calc_init", &
&                         "CenterZ is > 1")
       stop
    end if


    !==== γ, 
    allocate( ss_PotTempDisturb(DimXMin:DimXMax, DimZMin:DimZMax), &
         &    ss_ExnerDisturb(DimXMin:DimXMax, DimZMin:DimZMax),   &
         &    fs_VelXDisturb(DimXMin:DimXMax, DimZMin:DimZMax),    &
         &    sf_VelZDisturb(DimXMin:DimXMax, DimZMin:DimZMax)  )

    ss_ExnerDisturb = 0.0d0
    ss_PotTempDisturb = 0.0d0
    fs_VelXDisturb = 0.0d0
    sf_VelZDisturb = 0.0d0
    

    !-----------------------------------------------------------
    !--- ʡؿξ
    !-----------------------------------------------------------
    select case (ExnerDisturbType)
       
    case ("Exner_Gauss_X")
       !--- X Υʬ
       mu = ( Xmax - Xmin ) * ExnerCenterX
       sigma = ( Xmax - Xmin ) * ExnerSigmaX
       
       do i = DimXMin, DimXMax
          ss_ExnerDisturb(i,:) = &
               & ExnerMax * dexp(-((s_X(i) - mu) / sigma )**2.0d0 / 2.0d0) 
       end do
       
    case ("Exner_Gauss_Z")    
       !--- Z Υʬ
       mu = ( Zmax - Zmin ) * ExnerCenterZ
       sigma = ( Zmax - Zmin ) * ExnerSigmaZ
       
       do k = DimZMin, DimZMax
          ss_ExnerDisturb(:,k) = &
               & ExnerMax * dexp(-((s_Z(k) - mu) / sigma)**2.0d0 / 2.0d0) 
       end do
       
    case ("Exner_Gauss_XZ")
       !--- Ʊ߾Υʬ
       mu = ( Xmax - Xmin ) * ExnerCenterX
       sigma = ( Xmax - Xmin ) * ExnerSigmaX
       
       do i = DimXMin, DimXMax
          ss_ExnerDisturb(i,:) = &
               & ExnerMax * dexp(-((s_X(i) - mu) / sigma)**2.0d0 / 2.0d0) 
       end do
       
       mu = ( Zmax - Zmin ) * ExnerCenterZ
       sigma = ( Zmax - Zmin ) * ExnerSigmaZ
       
       do k = DimZMin, DimZMax
          ss_ExnerDisturb(:,k) = ss_ExnerDisturb(:,k) &
               & * dexp(-((s_Z(k) - mu) / sigma)**2.0d0 / 2.0d0) 
       end do
    end select

    !-----------------------------------------------------------
    !--- ̤ξ
    !-----------------------------------------------------------
    select case (PotTempDisturbType)
       
    case ("PotTemp_Gauss_X")
       !--- X Υʬ
       mu = ( Xmax - Xmin ) * PotTempCenterX
       sigma = ( Xmax - Xmin ) * PotTempSigmaX
       
       do i = DimXMin, DimXMax
          ss_PotTempDisturb(i,:) = &
               & PotTempMax * dexp(-((s_X(i) - mu) / sigma)**2.0d0 / 2.0d0) 
       end do
       
    case ("PotTemp_Gauss_Z")
       !--- Z Υʬ
       mu = ( Zmax - Zmin ) * PotTempCenterX
       sigma = ( Zmax - Zmin ) * PotTempSigmaZ
       
       do k = DimZMin, DimZMax
          ss_PotTempDisturb(:,k) = &
               & PotTempMax * dexp(-((s_Z(k) - mu) / sigma)**2.0d0 / 2.0d0) 
       end do
       
    case ("PotTemp_Gauss_XZ")     
       !--- Ʊ߾Υʬ
       mu = ( Xmax - Xmin ) * PotTempCenterX
       sigma = ( Xmax - Xmin ) * PotTempSigmaX
       
       do i = DimXMin, DimXMax
          ss_PotTempDisturb(i,:) = &
               & PotTempMax * dexp(-((s_X(i) - mu) / sigma)**2.0d0 / 2.0d0) 
       end do
       
       mu = ( Zmax - Zmin ) * PotTempCenterZ
       sigma = ( Zmax - Zmin ) * PotTempSigmaZ
       
       do k = DimZMin, DimZMax
          ss_PotTempDisturb(:,k) =  &
               & ss_PotTempDisturb(:,k) &
               &   * dexp(-((s_Z(k) - mu) / sigma)**2.0d0 / 2.0d0) 
       end do
       
!       where (ss_PotTempDisturb < PotTempMax * 1.0d-4)
!          ss_PotTempDisturb = 0.0d0 
!       end where
       
    case default
       
       ss_PotTempDisturb = 0.0d0
       
    end select

     
    !----------------------------------------------------------
    !--- ®
    !----------------------------------------------------------
    select case (VelDisturbType)
       
    case ("Zero")
       fs_VelXDisturb = 0.0d0
       sf_VelZDisturb = 0.0d0
       
    case ("VelX_test")
       fs_VelXDisturb = VelX
       fs_VelXDisturb(-5:10, :) = 0.0d0
       fs_VelXDisturb(90:105, :) = 0.0d0
       sf_VelZDisturb = 0.0d0
       
    case ("VelX_Uniform")
       !--- ® u 
       fs_VelXDisturb = VelX
       sf_VelZDisturb = 0.0d0
       
    case ("VelZ_Uniform")
       !--- ® w 
       fs_VelXDisturb = 0.0d0
       sf_VelZDisturb = VelZ
       
    case ("Solid_Rotation")
       !--- ΰ濴ιβž
       
       do i = DimXMin, DimXMax   
          fs_VelXDisturb(i,:) = &
               & 2.0d0*pi / 1000.0d0 * ( f_Z(:) - (Zmax + Zmin) / 2.0D0 )
       end do
       
       do k = DimZMin, DimZMax
          sf_VelZDisturb(:,k) = - 2.0d0 * pi / 1000.0d0 &
               &                 * ( s_X(:) - (Xmax + Xmin) / 2.0D0 )
       end do
       
    end select
    
    call EndSub("disturbset_calc_init")
    
  end subroutine disturbset_calc_init
  
end module disturbset
