!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module TimeSet
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: timeset.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!NAMELIST ֤Ԥ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!
                                                                 !=end

module timeset
  implicit none
  save
                                                                 !=begin
  !== Public Interface
  real(8)           :: DelTimeLong   !Ĺॹƥå
  real(8)           :: DelTimeShort  !ûॹƥå
  real(8)           :: TimeInt    !ʬ
  real(8)           :: TimeDisp   !եϤֳִ
  integer           :: NstepLong !ĹॹƥåפΥƥå׿
  integer           :: NstepShort!ûॹƥåפΥƥå׿
                                                                 !=end  
contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
  !
  subroutine timeset_init(cfgfile)

    !=== Dependency
    use dc_trace,      only: BeginSub, EndSub 
    use dc_message,    only: MessageNotify

    !=== Input
    character(*), intent(in) :: cfgfile
    
    !=== NAMELIST
    NAMELIST /timeset/ &
         & DelTimeLong, DelTimeShort, TimeInt, TimeDisp
                                                                 !=end    

    call BeginSub("timeset_init", &
&                 fmt="%c",       &
&                 c1="Initialize parameters of time integration. ")
        
    open (10, FILE=cfgfile)
    read(10, NML=timeset)
    close(10)

    !--- 롼ײ
    NstepLong = TimeInt / DelTimeLong 
    NstepShort = 2 * DelTimeLong / DelTimeShort

    !=== ʬ֤Ĺ֥ƥåפǳڤʤˤϷٹФ
    if(mod(TimeInt, DelTimeLong) /= 0) then 
       call MessageNotify("Message", "timeset_init", &
&                         "mod(TimeInt, DelTimeLong) is not zero")
    end if
    
    !=== Ĺ֥ƥåפû֥ƥåפǳڤʤˤϷٹФ
    if(mod(DelTimeLong, DelTimeShort) /= 0) then 
       call MessageNotify("Message", "timeset_init", &
&                         "mod(DelTimeLong, DelTimeShort) is not zero")
    end if

    !=== ʬ֤ϻֳִ֤ǳڤʤˤϷٹФ
    if(mod(TimeDisp, DelTimeLong) /= 0) then 
       call MessageNotify("Message", "timeset_init", &
&                         "mod(TimeDisp, DelTimeLong) is not zero")
    end if


    !==== ǧ
    write(*,*) "DelTimeLong, DelTimeShort", DelTimeLong, DelTimeShort
!    write(*,*) "TimeInt", TimeInt
!    write(*,*) "TimeDisp", TimeDisp
    write(*,*) "NstepLong, NstepShort", NstepLong, NstepShort

    call EndSub("timeset_init")

  end subroutine timeset_init
  
end module timeset
