!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine CflCheck
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: cflcheck.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!CFL Υå. 
!ߤ X γʻֳ֤ CFL å
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!Error Handling  gt4f90io Ѥ褦ѹ
!
                                                                 !=end

subroutine cflcheck
                                                                 !=begin
  !== Dependency
  use dc_trace, only: BeginSub, EndSub
  use dc_message ,only: MessageNotify
  use gridset,  only: DelX
  use timeset,  only: DelTimeShort
  use basicset, only: ss_VelSoundBasicZ
                                                                 !=end
  !--- ۤηػ
  implicit none
  
  !--- ѿ
  real(8)                :: ss_VelSoundMax
  real(8)                :: Cfl

  call BeginSub("cflcheck", &
&              fmt="%c", &
&              c1="CFL condition check.")
  
  !--- ® CFL 
  ss_VelSoundMax = maxval(ss_VelSoundBasicZ)
  Cfl = DelX / ss_VelSoundMax 
  
  !--- ٹå
  if (DelTimeShort >= Cfl) then 
     write(*,*) "CFL Condition is broken, DelTimeShort * VelSound > DelX"
     write(*,*) "sound wave velocity", ss_VelSoundMax
     write(*,*) "DelX", DelX
     write(*,*) "DelTimeShort", DelTimeShort
     stop
  end if
  
  !--- ٹå
  if (DelTimeShort >= Cfl * 9.0d-1) then 
     write(*,*) "CFL Condition is nearly broken"
     write(*,*) "sound wave velocity", ss_VelSoundMax
     write(*,*) "DelX", DelX
     write(*,*) "DelTimeShort", DelTimeShort
  end if
  
  !--- ٹå
  if (ss_VelSoundMax <= 0.0d0) then 
     call MessageNotify("Error", "cflcheck", &
&                  "sound wave velocity <= 0.0d0")
     stop
  end if

  call EndSub("cflcheck")
  
end subroutine cflcheck
