!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module Linlib
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: linlib.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3-20050902 $
!   * Change History: 
!
!== Overview 
!
!׻饤֥ SSL II  LAPACK Υåѡ
!
!== Error Handling
!
!== Known Bugs
!
!LAPACK 򤹤ʬ򥳡ǥ󥰤Ƥʤ. 
!
!== Note
!
!== Future Plans
!
                                                                 !=end

module linlib
  implicit none
  
  private
                                                                 !=begin
  !== Public Interface
  public linlib_init       !롼
  public linsolv           ! 3 ϢΩ 1 ()

  integer       :: LN = 10 !Υ. ͤϥߡ
  character(1)  :: LLib    !Ѥ饤֥Υե饰

  save LLib, LN
                                                                 !=end    
contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !Ѥ׻ѥå NAMELIST ꤷ, 
  !礭ꤹ
  !
  subroutine linlib_init(cfgfile, N)

    !=== Dependency
    use dc_trace, only : BeginSub, EndSub
    use dc_message, only: MessageNotify
    use ssl2_linear, only: ssl2_ltx_init
    use lapack_linear, only: lapack_dgtsv_init

    !=== Input
    integer, intent(in)      :: N       !󥵥
    character(*), intent(in) :: cfgfile !ե (NAMELIST)
    
    !=== NAMELIST
    NAMELIST /linlib/ LLib
                                                                 !=end
    open (10, FILE=cfgfile)
    read(10, NML=linlib)
    close(10)

    call BeginSub("linlib_init", &
&                 fmt="%c",       &
&                 c1="Initialize linear algebra library.")

    !--- 󥵥ݴ
    LN = N

    !--- Ѥ饤֥ν
    if (LLib == 's') then 
       call MessageNotify("Message", "linlib.f90", &
&                         "Call SSL II in the calculation")

       call ssl2_ltx_init(LN)

    elseif (LLib == 'l') then 
       call MessageNotify("Message", "linlib.f90", &
&                         "Call LAPACK in the calculation")

       call lapack_dgtsv_init(LN)

    else
      call MessageNotify("Error", "linlib.f90", &
&                        "Unknown LLib ", c1=LLib)
    end if

    call EndSub("linlib_init")

  end subroutine linlib_init
  
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !Ѥ׻ѥåϤ
  !
  subroutine LinSolv(A, B, C, D)

    !=== Dependency
    use dc_trace, only : BeginSub, EndSub
    use dc_message, only: MessageNotify
    use ssl2_linear, only: ssl2_ltx
    use lapack_linear, only: lapack_dgtsv

    !=== Input
    real(8), intent(in)    :: A(LN)
    real(8), intent(in)    :: B(LN-1)
    real(8), intent(in)    :: C(LN-1) 

    !=== In/Out
    real(8), intent(inout) :: D(LN)
                                                                 !=end

    !=== Work
    real(8)                :: AA(LN)
    real(8)                :: BB(LN-1)
    real(8)                :: CC(LN-1) 


    call BeginSub("linsolv", &
&                 fmt="%c",       &
&                 c1="call linear algebra library.")

    !--- Ѥ饤֥ν
    if (LLib == 's') then 
       call ssl2_ltx(A, B, C, D)

    elseif (LLib == 'l') then 
       !=== ° inout ʤΤ, ѿȤȤ.
       AA = A; BB = B; CC = C
       call lapack_dgtsv(AA, BB, CC, D)
       
    else
      call MessageNotify("Error", "linlib", &
&                        "unknown LLib")
    end if

    call EndSub("linsolv")

  end subroutine LinSolv
  
end module linlib
